package Datascope;


use 5.006;
use strict;
use warnings; 
use Carp;

require Exporter;
require DynaLoader;
use AutoLoader;

our($VERSION, @ISA, @EXPORT, $AUTOLOAD);
@ISA = qw(Exporter DynaLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	announce
	announce_str
	banner
	datafile
	datapath
	dbadd
	dbaddchk
	dbadd_remark
	dbaddnull
	dbaddv
	dbbase
	dbclose
	dbcompile
	dbcreate
	dbcrunch
	dbdelete
	dbdestroy
	dbex_eval
	dbextfile
	dbfind
	dbfree
	dbget
	dbget_range
	dbget_remark
	dbgetv
	dbgroup
	dbinvalid
	dbjoin
	dblookup
	dbmark
	dbmatches
	dbnextid
	dbnojoin
	dbopen
	dbopen_database
	dbopen_table
	dbflush_indexes
	dbput
	dbputv
	dbquery
	dbsave_view
	dbselect
	dbselect_hdr
	dbsever
	dbseparate
	dbsort
	dbstrtype
	dbsubset
	dbtheta
	dbtmp
	dbprocess
	dbtruncate
	dbunjoin
	elog_set
	elog_query
	elog_callback
	elog_clear
	elog_complain
	elog_die
	elog_flush
	elog_init
	elog_log
	elog_mark
	elog_notify
	elog_alert
	elog_debug
	elog_string
	epoch
	errno
	legit_ip
	str2epoch
	epoch2str
	is_epoch_string
	strlocaldate
	strlocaltime
	strlocalydtime
	strdate
	strtime
	strtdelta
	strydtime
	yearday
	bury
	resurrect
	exhume
	grn
	grname
	srn
	srname
	askyn
	askynaq
	ask
	limit
	pfnew
	pfcompile
	pfupdate
	pfdel
        pfget
        pfget2
	pfget_boolean
	pfget_time
	pfget_size
	pffiles
	pfput
	pfwrite
	pf2string
	autodrm_net
	autodrm_aux
	map_autodrm_netsta
	map_autodrm_chanaux
	map_seed_netsta
	map_seed_chanloc
	latlon
	dist
	deg
	rad
	carsph
	sphcar
	mapcenter
	rotation
	rotate
	r3cross
	r3mag
	r3dot
	r3orthonormal
	r3norm
	seed_net
	seed_loc
	snooze
	trcopy
	trcreate
	trdata
	trdestroy
	trputdata
	trsplice
	trsplit
	trfree
	trloadchan
	trsample
	trfilter
	wfchanid
	now
	makedir
	abspath
	relpath
	cleanpath
	close_descriptors
	concatpaths
	parsepath
	finit_db 
	avgring
	closering
	countring
	tallyring
	changedring
	findring
	getring
	maxring
	minring
	newring
	openring
	meanring
	linearfitring
	cramring
	pfrequire
	pushring
        strsignal
	sgsign
	sgverify
	sha
	trlookup_segtype 
	wait_for_time
	units_convert
	units_match
	yesno
	is_nfs
	hls2rgb
	rgb2hls
	INVALID_DBPTR
	dbALL
	dbALTERNATE_KEY
	dbBDOUBLE
	dbBFLOAT
	dbBINT
	dbBOOLEAN
	dbBSHORT
	dbCOUNT
	dbDATABASE_COUNT
	dbDATABASE_DESCRIPTION
	dbDATABASE_DETAIL
	dbDATABASE_FILENAME
	dbDATABASE_IS_WRITABLE
	dbDATABASE_IS_WRITEABLE
	dbDATABASE_NAME
	dbDBPATH
	dbDBPTR
	dbDESCRIPTION
	dbDETAIL
	dbFIELD_BASE_TABLE
	dbFIELD_COUNT
	dbFIELD_DESCRIPTION
	dbFIELD_DETAIL
	dbFIELD_FORMAT
	dbFIELD_INDEX
	dbFIELD_NAME
	dbFIELD_RANGE
	dbFIELD_SIZE
	dbFIELD_TABLES
	dbFIELD_TYPE
	dbFIELD_UNITS
	dbFOREIGN_KEYS
	dbFORMAT
	dbIDSERVER
	dbINTEGER
	dbINVALID
	dbLASTIDS
	dbLINK
	dbLINK_FIELDS
	dbLOCKS
	dbNAME
	dbNULL
	dbOUTER_JOIN
	dbPRIMARY_KEY
	dbREAL
	dbRECORD_COUNT
	dbRECORD_SIZE
	dbRESPONSE
	dbSCHEMA_DEFAULT
	dbSCHEMA_DESCRIPTION
	dbSCHEMA_DETAIL
	dbSCHEMA_FIELDS
	dbSCHEMA_LIST
	dbSCHEMA_NAME
	dbSCHEMA_TABLES
	dbSCRATCH
	dbSIZE
	dbSORT_REVERSE
	dbSORT_UNIQUE
	dbSTRING
	dbTABLE_ADDRESS
	dbTABLE_COUNT
	dbTABLE_CREATION
	dbTABLE_DESCRIPTION
	dbTABLE_DETAIL
	dbTABLE_DIRNAME
	dbTABLE_FIELDS
	dbTABLE_FILENAME
	dbTABLE_IS_ADDABLE
	dbTABLE_IS_TRANSIENT
	dbTABLE_IS_VIEW
	dbTABLE_IS_WRITABLE
	dbTABLE_IS_WRITEABLE
	dbTABLE_NAME
	dbTABLE_PRESENT
	dbTABLE_SIZE
	dbTIME
	dbTIMEDATE_NAME
	dbTYPE
	dbUNIQUE_ID_NAME
	dbVIEW_TABLES
	dbVIEW_TABLE_COUNT
	dbWAVEFORM
	dbYEARDAY
	strEXPR
	strFIELD
	strINTEGER
	strNULL
	strREAL
	strSTRING
	strTIME
	strUNKNOWN
	INT_RELIC
	DOUBLE_RELIC
	STRING_RELIC
	TIME_RELIC 
);

$Datascope::version     = "5.0";
$Datascope::patchLevel  = "5.0";
$Datascope::VERSION     = '5.0';

sub AUTOLOAD {
    my($constname);
    ($constname = $AUTOLOAD) =~ s/.*:://;
    my ($val) = constant($constname);
    no strict 'refs';
    *{$AUTOLOAD} = sub { $val };
    goto &{$AUTOLOAD};
}

bootstrap Datascope $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

dbperl - perl5 interface to Datascope

=head1 SYNOPSIS

=item B<dbopen> (database, permissions)
=item B<dbopen_table> (database, permissions)
=item B<dblookup> (@db, database, table, field, record)
=item B<dbget> (@db [, 0])
=item B<dbput> (@db [, string])
=item B<dbgetv> (@db, field_name, [field_name, ...])
=item B<dbputv> (@db, field_name, value, [field_name, value, ...])
=item B<dbsave_view> (@db, table_name)
=item B<dbunjoin> (@db, database_name)
=item B<dbcompile> (@db, string)
=item B<dbex_eval> (@db, expression)
=item B<dbextfile(@db[,> base-table])
=item B<dbadd> (@db, [record])
=item B<dbaddnull> (@db)
=item B<dbadd_remark> (@db, remark)
=item B<dbget_remark> (@db)
=item B<dbaddv> (@db, field_name, value, [field_name, value, ...])
=item B<dbquery> (@db, code)
=item B<dbnojoin> (db1, db2, [join-keys])
=item B<dbjoin> (@db1, @db2, [join-keys])
=item B<dbmatches> (@db1, @db2, hookname, [join-keys])
=item B<dbtheta> (@db1, @db2, [expression])
=item B<dbsubset> (@db, expression)
=item B<dbprocess> (@db, cmd1, cmd2, cmd3 ... )
=item B<dbmark> (@db)
=item B<dbclose> (@db)
=item B<dbfree> (@db)
=item B<dbdelete> (@db)
=item B<dbtruncate> (@db, n)
=item B<dbcrunch> (@db)
=item B<dbdestroy> (@db)
=item B<dbnextid> (@db, id_name)
=item B<dbsort> (@db, [-u,] [-r,] [key, key..])
=item B<dbgroup> (@db, key, [key, ...])
=item B<elog_init> ($0, @ARGV)
=item B<elog_notify> msg
=item B<elog_log> msg
=item B<elog_complain> msg
=item B<elog_die> msg
=item B<elog_clear>
=item B<elog_flush> deliver first
=item B<elog_mark>
=item B<epoch> (yearday)
=item B<yearday> (epoch)
=item B<str2epoch> (string)
=item B<epoch2str> (epoch, fmt)
=item B<epoch2str> (epoch, fmt, timezone)
=item B<epoch2str> (epoch, fmt, timezone)
=item B<strtime> (epoch)
=item B<strdate> (epoch)
=item B<strydtime> (epoch)
=item B<strtdelta> (epoch)
=item B<datapath> (env, dir, file, suffix)
=item B<datafile> (env, file)
=item B<grn> (lat, lon)
=item B<srn> (lat, lon)
=item B<grname> (lat, lon)
=item B<srname> (lat, lon)
=item B<askyn> (string)
=item B<ask> (string)
=item B<pfget> (pfname, key)
=item B<pfupdate> (pfname)
=item B<limit> (resource, [limit2set])

=head1 DESCRIPTION

The perl interface has approximately
the same breadth as the tcl interface, with more of a c flavor.
In keeping with the spirit of scripts, most routines generate a perl error
when an error occurs, rather than returning bad result code.  In perl,
of course, you can intercept these errors by using eval.
When an error occurs, the returned message is the complete
contents of the error log.

Note that the perl interface, like the tcl interface, is an interface
to the Datascope library routines, not an interface to the shell commands.
(You can, of course, run the shell commands directly from perl or tcl).

Database pointers are most conveniently kept in perl arrays, though because
of the perl calling conventions, you may alternatively keep them in
a set of scalar variables.

The various predefined constants (like dbRECORD_COUNT) are not part of
the package; this may be a mistake.  dbquery expects a string instead.
Note that dblookup will recognize "dbNULL" and "dbSCRATCH" in the
record field.

Following are brief descriptions of the Datascope functions implemented.

=head2 Datascope functions


=over 2

=item B<dbopen> (database, permissions)

Returns a database pointer to the specified database.
    C<>
    C<@db = dbopen ( $database, "r+" ) ;>

=item B<dbopen_table> (database, permissions)

Returns a database pointer to the specified database table; a name
of "-" reads a view from stdin.
    C<>
    C<@db = dbopen ( "demo.wfdisc", "r+" ) ;>

=item B<dblookup> (@db, database, table, field, record)

Returns a database pointer for the specified database, table, field,
and record.  Use "", not 0, for the unspecified values.
    C<>
    C<@db = dblookup(@db, "", "wfdisc", "", "" ) ;>

=item B<dbget> (@db [, 0])

Returns the specified table, record, or field from the database, or
if a second argument is specified, copies the value into the scratch
record (except if a whole table is requested):
    C<>
    C<$record = dbget(@db) ;>

=item B<dbput> (@db [, string])

Saves the specified string into the specified table, record or field.
If no string is specified, the value is taken from the scratch record:
    C<>
    C<dbput(@dbevent, "This is a bad replacement record" ) ;>

=item B<dbgetv> (@db, field_name, [field_name, ...])

Returns the values of the specified fields for a particular record:
    C<>
    C<($sta, $chan, 13:53 ) = dbgetv(@db, qw( sta chan time ) );>
    C<>
For a database pointer, like B<bundle> from dbgroup(3), use the
following syntax:
    C<>
    C<($dbbundle) = dbgetv(@db, "bundle" );>
    C<@dbbundle = split ( ' ', $dbbundle ) ;>
    C<>

=item B<dbputv> (@db, field_name, value, [field_name, value, ...])

Saves the specified values into the specified fields for a particular record.
    C<>
    C<dbputv(@dbevent, "auth", "Quinlan", "evname", "DQ") ;>

=item B<dbsave_view> (@db, table_name)

Saves the view into a file named after the database and tablename.
    C<>
    C<dbsave_view(@dbsubset, "asubset") ;>

=item B<dbunjoin> (@db, database_name)

Creates a new database, which contains all the records referenced in the
input view.  Any existing database of the same name will be overwritten.
    C<>
    C<dbunjoin(@dbsubset, "copy") ;>

=item B<dbcompile> (@db, string)

Add new attributes or relations to the schema directly from the perl script.
The string must contain valid schema statements.
    C<>
    C<dbcompile(@db, "Relation test Fields (sta chan time commid lddate)>
    C<Primary (sta chan time) ; ") ;>

=item B<dbex_eval> (@db, expression)

Evaluate an expression for a particular record.
    C<>
    C<$distance = dbex_eval ( @db,>
    C<"distance (lat, lon, site.lat, site.lon) ) ;>

=item B<dbextfile(@db[,> base-table])

return the filename for an external file for a particular record in
a view, for a particular base-table if specified.
    C<>
    C<$filename = dbextfile(@db) ;>

=item B<dbadd> (@db, [record])

Add the new record to the table specified in @db.  If no record is specified,
use the scratch record.  Returns the new record number.
    C<>
    C<$dbevent[3] = dbadd(@dbevent, "this is not a good event record") ;>

=item B<dbaddnull> (@db)

Add a new null record to a table.
    C<>
    C<$new = dbaddnull(@dbevent) ;>

=item B<dbadd_remark> (@db, remark)

Add a comment in the remark table for the specified table/record.
    C<>
    C<dbadd_remark ( @dbevent, "This is a comment" ) ;>

=item B<dbget_remark> (@db)

Get any comment from the remark table for the specified table/record.
    C<>
    C<$return = dbget_remark ( @dbevent ) ;>

=item B<dbaddv> (@db, field_name, value, [field_name, value, ...])

Add a new record with the specified values to the database.
New records are checked to insure the keys are filled out and don't
conflict with other records in the table.
If the id key in a defining table (orid in the origin table, for example)
is not specified, a new id will automatically be generated, using dbnextid.
    C<>
    C<$new = dbaddv(@dbevent, "evid", 1,>
    C<"evname", "fake",>
    C<"prefor", 1,>
    C<"auth", "danq") ;>

=item B<dbquery> (@db, code)

Query the database for information.  The standard Datascope codes must
be in quotes.
    C<>
    C<$nrecords =  dbquery(@db, "dbRECORD_COUNT") ;>
    C<$description = dbquery(@db, "dbTABLE_DESCRIPTION") ;>
    C<$detail = dbquery(@db, "dbTABLE_DETAIL") ;>
    C<@primary = dbquery(@db, "dbPRIMARY_KEY");>
    C<$ntables = dbquery(@db, "dbTABLE_COUNT") ;>
    C<%defining_tables = dbquery(@db, "dbLINK_FIELDS" ) ;>
    C<@ids = keys %defining_tables ;>

=item B<dbnojoin> (db1, db2, [join-keys])

An attempt is made to join the two tables, using the the join-keys if specified.
Any records from the first table which do not join are put into a new view,
which is returned.
    C<>
    C<@records = dbnojoin ( @dbassoc, @dborigin ) ;>
    C<printf "Records @records in assoc have no matching record in origin\n" ;>

=item B<dbjoin> (@db1, @db2, [join-keys])

returns a new view which is the join of the two tables, using the
join-keys if specified.
    C<>
    C<@db1 = dbjoin ( @dbassoc, @dborigin ) ;>
    C<@db1 = dbjoin ( @db1, @dbarrival ) ;>

=item B<dbmatches> (@db1, @db2, hookname, [join-keys])

returns a list of the records in db2 which match the record specified by
db1.  hookname is an arbitrary name which must uniquely specify the join.
    C<>
    C<@dbsite = dblookup (@db, "", "origin", "orid", "125" ) ;>
    C<@records = dbmatches ( @dborigin, @dbassoc, "origin2assoc" ) ;>
    C<foreach $i ( @records ) {>
    C<$dbassoc[3] = $i ;>
    C<($arid, $phase, $delta) = dbgetv ( @dbassoc, qw(arid, phase, delta) ) ;>
    C<}>

=item B<dbtheta> (@db1, @db2, [expression])

returns a new view which is any combination of rows from the
two tables which satisfies the expression, or all combinations
if no expression is specified.
    C<>
    C<@dbnearby = dbtheta ( @dborigin, @dbsite,>
    C<"distance(lat,lon,site.lat, site.lon) < 10." ) ;>

=item B<dbsubset> (@db, expression)

returns a new view which is the set of all row which satisfy the expression
    C<>
    C<@dbsubsetted = dbsubset ( @dbwfdisc, "sta=='AAK'" ) ;>

=item B<dbprocess> (@db, cmd1, cmd2, cmd3 ... )

returns a new view which is the result of applying the dbprocess
commands cmd1, cmd2, etc to the input database pointer.
    C<>
    C<@dbprocess = dbprocess ( @db, "dbopen wfdisc",>
    C<"dbjoin site",>
    C<"dbsubset distance(38,-104,lat,lon)<15") ;>

=item B<dbmark> (@db)

sets the specified B<record> to all null values.

=item B<dbclose> (@db)

closes the database, freeing all resources used by it.

=item B<dbfree> (@db)

frees resources for a table or a database.

=item B<dbdelete> (@db)

physically deletes B<a record> from the database.  This invalidates
all views which use this table.

=item B<dbtruncate> (@db, n)

Truncate a table to the specified number of records.

=item B<dbcrunch> (@db)

Deletes all marked (null) records from the specified table.

=item B<dbdestroy> (@db)

Deletes all tables and the descriptor file for the specified database.

=item B<dbnextid> (@db, id_name)

Gets the next free id value for the specified database and id_name.
    C<>
    C<$arid = dbnextid ( @db, "arid" ) ;>

=item B<dbsort> (@db, [-u,] [-r,] [key, key..])

returns a new view which is the input table sorted according to the specified
keys, or the primary key if no keys are specified.
    C<>
    C<@dbsorted = dbsort ( @dbwfdisc, "sta", "chan", "time" ) ;>

=item B<dbgroup> (@db, key, [key, ...])

returns a new view which is the input table grouped according to the specified
keys
    C<>
    C<@dbg = dbgroup ( @dbwfdisc, "sta", "chan" ) ;>

=back

=head2 Elog error facility routines


=over 2

=item B<elog_init> ($0, @ARGV)

initialize the elog message routines

=item B<elog_notify> msg

Send a message other than an error message to the elog
facility.

=item B<elog_log> msg

Save a message on the elog message log.

=item B<elog_complain> msg

Write an error message to the elog message facility for
immediate output.

=item B<elog_die> msg

Write a message to the elog message facility and die.

=item B<elog_clear>

Clear the elog message log.

=item B<elog_flush> deliver first

Get rid of messages after  #first  in  the  error  log,
printing them if deliver is a boolean true.

=item B<elog_mark>

return the count of messages  currently  held  in  the
error log.

=back

=head2 Time conversion routines


=over 2

=item B<epoch> (yearday)

Returns the epoch time corresponding to the integer yearday (eg, 1994305).
    C<>
    C<13:53 = epoch ( 1995067 ) ;>

=item B<yearday> (epoch)

Returns the yearday corresponding to an epoch time.
    C<>
    C<$jdate = yearday ( 794705400.0 ) ;>
    C<>

=item B<str2epoch> (string)

Returns the epoch time corresponding to the free-form input time/date.
    C<>
    C<13:53 = str2epoch ( "July 20, 1992 18:30" ) ;>
    C<>

=item B<epoch2str> (epoch, fmt)


=item B<epoch2str> (epoch, fmt, timezone)

returns the epoch time formatted according to the fmt string; see
epoch2str(3) for details.
    C<>
    C<print epoch2str(13:53, "%A %B %d, %Y %T%n" ) ;>
    C<>

=item B<epoch2str> (epoch, fmt, timezone)

returns the epoch time formatted according to the fmt string and
converted to the respective local time for timezone ; see
epoch2str(3) for details.

=item B<strtime> (epoch)

Returns a formatted string of the time and date.

=item B<strdate> (epoch)

Returns a formatted string of the date.

=item B<strydtime> (epoch)

Returns a formatted string of the time and date, including the day of year.

=item B<strtdelta> (epoch)

Returns a formatted string of the specified time interpreted as a time difference, eg "2.5 days"
    C<>
    C<printf "The time difference is %s\n", strtdelta($time2-$time1) ;>
    C<>

=back

=head2 Miscellaneous


=over 2

=item B<datapath> (env, dir, file, suffix)


=item B<datafile> (env, file)

Finds the specified file by looking at first the environment variable,
and then along the path.
    C<>
    C<$schemafile = ( "SCHEMADIR", "css3.0" ) ;>
    C<>

=item B<grn> (lat, lon)


=item B<srn> (lat, lon)


=item B<grname> (lat, lon)


=item B<srname> (lat, lon)

return geographic and seismic region numbers (grn and srn) or
names (grname and srname):
    C<>
    C<$name = grname ( 38.5, -108 ) ;>
    C<>

=item B<askyn> (string)


=item B<ask> (string)

Pose the question I<string> of the controlling tty, and return the
response.  B<askyn> returns only true or false, and accepts only
certain kinds of answers (yes/no, true/false, ok, 0/1, ..  )
    C<>
    C<$reply = ask ( "how high? " ) ;>

=item B<pfget> (pfname, key)

extracts the value for the specified key from the specified parameter
file pfname.  The key is actually the compound key which pfeval(3)
recognizes.  This is a perl-type syntax for picking out a certain
element in a parameter file.  For example, a key of
"outer_array{2nd_list[2]}" would return a reference to the value
"Eureka" if the parameter file included:
    C<>
    C<outer_array     &Arr{>
    C<1st_list        &Tbl{>
    C<ho>
    C<hum>
    C<}>
    C<2nd_list        &Tbl{>
    C<item0>
    C<item1>
    C<Eureka>
    C<item3>
    C<}>
    C<}>
    C<>
In the case of nested arrays or lists, the reference returned by pfget
may be a reference to a perl array or associative array, and the elements
of these arrays might also be references to arrays or associative arrays.
    C<>
    C<$listref = pfget("above.pf", (outer_array{2nd_list}" )  ;>
    C<@list = @$listref ;>

=item B<pfupdate> (pfname)

checks and rereads a parameter file if one of the components along
PFPATH has changed.  It returns 0 when no read was necessary, 1
if a read were necessary.

=item B<limit> (resource, [limit2set])

limit may be used to return the current resource limit, or set a new resource
limit.  The resources which may be set are:
    C<>
    C<cputime>
    C<filesize>
    C<datasize>
    C<stacksize>
    C<coredumpsize>
    C<vmemoryuse>
    C<descriptors>
    C<>
These correspond exactly to the limit command of tcsh(1).
    C<>
    C<limit ( coredumpsize, "unlimited" ) ;>
    C<>

=back

=head1 EXAMPLE


Here's a quick example which uses some of the interface routines:
    C<>
    C<#! /usr/bin/perl -w>
    C<>
    C<use Datascope ;>
    C<>
    C<$database = $ARGV[0] ;>
    C<@db = dbopen ( $database, "r+" ) ;>
    C<@db = dblookup(@db, "", "wfdisc", "", "" ) ;>
    C<>
    C<$db[3] = 0 ;>
    C<$record = dbget(@db) ;>
    C<print "The first record in the table is '$record'\\n" ;>
    C<>
    C<( $sta ) = dbgetv(@db, "sta") ;>
    C<print "sta is $sta\\n" ;>
    C<>
    C<($sta, $chan, 13:53, $wfid ) = dbgetv(@db, qw( sta chan time wfid ) );>
    C<$stime = &strydtime(13:53) ;>
    C<print "That's $stime\\n" ;>
    C<>
    C<$nrecords =  dbquery(@db, "dbRECORD_COUNT") ;>
    C<print "table has $nrecords records\\n" ;>
    C<$description = dbquery(@db, "dbTABLE_DESCRIPTION") ;>
    C<print "Description: $description\\n" ;>
    C<>
    C<@primary = dbquery(@db, "dbPRIMARY_KEY");>
    C<print "Primary key: @primary\\n" ;>
    C<>
    C<@db = dblookup(@db, "", "wfdisc", "", "" ) ;>
    C<print "db is @db\\n" ;>
    C<@dbsensor = dblookup(@db, "", "sensor", "", "") ;>
    C<@dbjoin = dbjoin(@db, @dbsensor) ;>
    C<@dbsorted = dbsort(@dbjoin, "sta", "chan" ) ;>
    C<@dbsubset = dbsubset(@dbsorted, "chan == 'BHZ'" ) ;>
    C<>
    C<dbsave_view(@dbsubset, "asubset") ;>
    C<dbunjoin(@dbsubset, "copy") ;>
    C<>
    C<print "destroying database copy\\n" ;>
    C<dbdestroy(@dbcopy) ;>
    C<# dbdestroy closes the database>
    C<@dbcopy = dbopen ( "copy", "r+" ) ;>
    C<>
    C<@dbevent = dblookup ( @db, "", "event", "", "" ) ;>
    C<$new = dbaddv(@dbevent, "evid", 1,>
    C<"evname", "fake",>
    C<"prefor", 1,>
    C<"auth", "danq") ;>
    C<>
    C<dbcompile(@db, "Relation test Fields (sta chan time commid lddate) Primary (sta chan time) ; ") ;>
    C<@dbtest = dblookup(@db, "", "test", "", "" ) ;>
    C<>

=head1 RETURN VALUES

dbopen, dbopen_table, dblookup, dbjoin, dbtheta, dbsubset, dbsort, and
dbgroup
all return database pointers.

dbget returns a single field, record, or table.

dbgetv returns a list of all the field values requested; when a dbptr is
the requested field, it is returned as a single string which must be split
into the various components, eg:
    C<>
    C<@db = split ( ' ', $dbptr ) ;>
    C<>

dbput, dbputv, dbsave_view, dbunjoin, dbcompile, dbadd_remark, dbmark,
dbclose, dbdelete, dbfree, dbtruncate, dbcrunch, dbdestroy, and limit
have no return value.

dbadd, dbaddnull and dbaddv return the record number of the add record.

dbex_eval returns the value of the expression.

dbextfile returns the name of the external file.

dbget_remark returns the requested comment from the remark table.

dbquery returns the requested value.
Usually this is a scalar, but in
the case of dbSCHEMA_FIELDS, dbFIELD_TABLES,
dbVIEW_TABLES, dbSCHEMA_TABLES, dbTABLE_FIELDS, dbPRIMARY_KEY,
dbALTERNATE_KEY, and dbFOREIGN_KEYS, a list is returned.

dbquery of
dbFIELD_TYPE returns the string "dbINTEGER", "dbREAL", "dbTIME",
"dbDATE", "dbYEARDAY", "dbSTRING", or "dbDBPTR".

dbquery of dbLINK_FIELDS returns an array.

dbnojoin and dbmatches return a list of record numbers.

dbnextid returns the integer next id.

elog_mark returns an integer

epoch and str2epoch return a real time.

yearday returns an integer = year * 1000 + day of year.

epoch2str, strtime, strdate, strydtime and  strtdelta return a formatted
string representing a time.

datapath and datafile return file names.

grn and srn return integers; grname and srname return strings.

askyn returns either 0 (no) or 1 (yes).
ask returns the reply string.

pfget returns either a string, or a reference to a list or a reference
to an array.

=head1 SEE ALSO

    C<dbintro(3)>
    C<dbschema(5)>

=head1 BUGS AND CAVEATS


When an error occurs during the execution of one of these calls,
the routine does not return normally, usually causing the script
to abort.  You must wrap a call inside an eval statement if you wish
to continue a script under these conditions.

When referring to the (more detailed) c documentation for these routines,
be sure to look at the man pages in section 3, rather than the man pages
in section 1.  dbdelete(3) (which is implemented by the perl interface)
deletes one record at a time, whereas dbdelete(1) takes as input a view
and deletes every record in the view.

Needs better method of getting the Datascope #defined codes.
(dbREAL, dbNULL, dbRECORD_COUNT, etcetera).

=head1 AUTHOR

 Daniel Quinlan 
  danq@brtt.com

=cut
